/*------------------------------------------------------------
   Texel	(www.texel.fr.fm)		2001
   DirectX Audio
   Lecture d'un fichier audio
------------------------------------------------------------*/

#define INITGUID	// pour les indentificateurs GUID
#include <windows.h>
#include <dmusicc.h>
#include <dmusici.h>

// dclaration en globale
IDirectMusicLoader8*      g_pLoader         = NULL;
IDirectMusicPerformance8* g_pPerformance    = NULL;
IDirectMusicSegment8*     g_pSegment        = NULL;
IDirectMusicSegment8*     g_pSegment2        = NULL;

/*-----------------------------------------------------------------------------
									WinMain
-----------------------------------------------------------------------------*/
INT APIENTRY WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, 
                      INT nCmdShow )
{
    // Initialisation de COM
    CoInitialize(NULL);
    
    // Creation d'un objet Loader
    CoCreateInstance( CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, 
                      IID_IDirectMusicLoader8, (void**)&g_pLoader );

     // Creation d'un objet Performance
    CoCreateInstance( CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, 
                      IID_IDirectMusicPerformance8, (void**)&g_pPerformance );

    // Initialisation
    g_pPerformance->InitAudio( NULL, NULL, NULL, 
                               DMUS_APATH_SHARED_STEREOPLUSREVERB, 64,
                               DMUS_AUDIOF_ALL, NULL );

	// chargement d'un fichier son wave (ou midi)
    if( FAILED( g_pLoader->LoadObjectFromFile( CLSID_DirectMusicSegment,
                                               IID_IDirectMusicSegment8,
                                               L"toto.wav",
                                               (LPVOID*) &g_pSegment ) ) )
    {
        MessageBox( NULL, "Fichier non trouv!", 
                          "DirectX Audio: Lecture simple", MB_OK );
        return 0;
    }
	// chargement d'un fichier son wave (ou midi)
	if( FAILED( g_pLoader->LoadObjectFromFile( CLSID_DirectMusicSegment,
                                               IID_IDirectMusicSegment8,
                                               L"toto2.wav",
                                               (LPVOID*) &g_pSegment2 ) ) )
    {
        MessageBox( NULL, "Fichier non trouv!", 
                          "DirectX Audio: Lecture simple", MB_OK );
        return 0;
    }

    // tlchargement du segement vers le synthtiseur
    g_pSegment->Download( g_pPerformance );
	g_pSegment2->Download( g_pPerformance );

	// rptition des sons
	g_pSegment->SetRepeats( DMUS_SEG_REPEAT_INFINITE );
	g_pSegment2->SetRepeats( DMUS_SEG_REPEAT_INFINITE );



    // Lecture du fichier son
    g_pPerformance->PlaySegmentEx( g_pSegment, NULL, NULL, 0, 
                                   0, NULL, NULL, NULL );
	// lecture d'un second son (notez la diffrence des arguments)
	g_pPerformance->PlaySegmentEx( g_pSegment2, NULL, NULL,DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY |DSBPLAY_LOOPING, 
                                   0, NULL, NULL,NULL );

    // on fait une pause pour couter le rsultat
	 MessageBox( NULL, "Ok pour quitter!", "DirectX Audio: Lecture simple", MB_OK );

    // Arrt du son
    g_pPerformance->Stop( NULL, NULL, 0, 0 );
    g_pPerformance->CloseDown();

    // Libration des interfaces
    g_pLoader->Release(); 
    g_pPerformance->Release();
    g_pSegment->Release();
	g_pSegment2->Release();

    // On dinitialise le COM
    CoUninitialize();
        
    return 0;
}

